defmodule StellarBase.XDR.ContractCostType do
  @moduledoc """
  Automatically generated by xdrgen
  DO NOT EDIT or your changes may be overwritten

  Target implementation: elixir_xdr at https://hex.pm/packages/elixir_xdr

  Representation of Stellar `ContractCostType` type.
  """

  @behaviour XDR.Declaration

  @declarations [
    WasmInsnExec: 0,
    MemAlloc: 1,
    MemCpy: 2,
    MemCmp: 3,
    DispatchHostFunction: 4,
    VisitObject: 5,
    ValSer: 6,
    ValDeser: 7,
    ComputeSha256Hash: 8,
    ComputeEd25519PubKey: 9,
    VerifyEd25519Sig: 10,
    VmInstantiation: 11,
    VmCachedInstantiation: 12,
    InvokeVmFunction: 13,
    ComputeKeccak256Hash: 14,
    ComputeEcdsaSecp256k1Sig: 15,
    RecoverEcdsaSecp256k1Key: 16,
    Int256AddSub: 17,
    Int256Mul: 18,
    Int256Div: 19,
    Int256Pow: 20,
    Int256Shift: 21,
    ChaCha20DrawBytes: 22
  ]

  @enum_spec %XDR.Enum{declarations: @declarations, identifier: nil}

  @type t :: %__MODULE__{identifier: atom()}

  defstruct [:identifier]

  @spec new(type :: atom()) :: t()
  def new(type \\ :WasmInsnExec), do: %__MODULE__{identifier: type}

  @impl true
  def encode_xdr(%__MODULE__{identifier: type}) do
    @declarations
    |> XDR.Enum.new(type)
    |> XDR.Enum.encode_xdr()
  end

  @impl true
  def encode_xdr!(%__MODULE__{identifier: type}) do
    @declarations
    |> XDR.Enum.new(type)
    |> XDR.Enum.encode_xdr!()
  end

  @impl true
  def decode_xdr(bytes, spec \\ @enum_spec)

  def decode_xdr(bytes, spec) do
    case XDR.Enum.decode_xdr(bytes, spec) do
      {:ok, {%XDR.Enum{identifier: type}, rest}} -> {:ok, {new(type), rest}}
      error -> error
    end
  end

  @impl true
  def decode_xdr!(bytes, spec \\ @enum_spec)

  def decode_xdr!(bytes, spec) do
    {%XDR.Enum{identifier: type}, rest} = XDR.Enum.decode_xdr!(bytes, spec)
    {new(type), rest}
  end
end
