defmodule StellarBase.XDR.SCError do
  @moduledoc """
  Automatically generated by xdrgen
  DO NOT EDIT or your changes may be overwritten

  Target implementation: elixir_xdr at https://hex.pm/packages/elixir_xdr

  Representation of Stellar `SCError` type.
  """

  @behaviour XDR.Declaration

  alias StellarBase.XDR.{
    SCErrorType,
    UInt32,
    SCErrorCode
  }

  @arms [
    SCE_CONTRACT: UInt32,
    SCE_WASM_VM: SCErrorCode,
    SCE_CONTEXT: SCErrorCode,
    SCE_STORAGE: SCErrorCode,
    SCE_OBJECT: SCErrorCode,
    SCE_CRYPTO: SCErrorCode,
    SCE_EVENTS: SCErrorCode,
    SCE_BUDGET: SCErrorCode,
    SCE_VALUE: SCErrorCode,
    SCE_AUTH: SCErrorCode
  ]

  @type value ::
          UInt32.t()
          | SCErrorCode.t()

  @type t :: %__MODULE__{value: value(), type: SCErrorType.t()}

  defstruct [:value, :type]

  @spec new(value :: value(), type :: SCErrorType.t()) :: t()
  def new(value, %SCErrorType{} = type), do: %__MODULE__{value: value, type: type}

  @impl true
  def encode_xdr(%__MODULE__{value: value, type: type}) do
    type
    |> XDR.Union.new(@arms, value)
    |> XDR.Union.encode_xdr()
  end

  @impl true
  def encode_xdr!(%__MODULE__{value: value, type: type}) do
    type
    |> XDR.Union.new(@arms, value)
    |> XDR.Union.encode_xdr!()
  end

  @impl true
  def decode_xdr(bytes, spec \\ union_spec())

  def decode_xdr(bytes, spec) do
    case XDR.Union.decode_xdr(bytes, spec) do
      {:ok, {{type, value}, rest}} -> {:ok, {new(value, type), rest}}
      error -> error
    end
  end

  @impl true
  def decode_xdr!(bytes, spec \\ union_spec())

  def decode_xdr!(bytes, spec) do
    {{type, value}, rest} = XDR.Union.decode_xdr!(bytes, spec)
    {new(value, type), rest}
  end

  @spec union_spec() :: XDR.Union.t()
  defp union_spec do
    nil
    |> SCErrorType.new()
    |> XDR.Union.new(@arms)
  end
end
