defmodule StellarBase.XDR.LedgerKeyContractData do
  @moduledoc """
  Automatically generated by xdrgen
  DO NOT EDIT or your changes may be overwritten

  Target implementation: elixir_xdr at https://hex.pm/packages/elixir_xdr

  Representation of Stellar `LedgerKeyContractData` type.
  """

  @behaviour XDR.Declaration

  alias StellarBase.XDR.{
    SCAddress,
    SCVal,
    ContractDataDurability
  }

  @struct_spec XDR.Struct.new(
                 contract: SCAddress,
                 key: SCVal,
                 durability: ContractDataDurability
               )

  @type contract_type :: SCAddress.t()
  @type key_type :: SCVal.t()
  @type durability_type :: ContractDataDurability.t()

  @type t :: %__MODULE__{
          contract: contract_type(),
          key: key_type(),
          durability: durability_type()
        }

  defstruct [:contract, :key, :durability]

  @spec new(
          contract :: contract_type(),
          key :: key_type(),
          durability :: durability_type()
        ) :: t()
  def new(
        %SCAddress{} = contract,
        %SCVal{} = key,
        %ContractDataDurability{} = durability
      ),
      do: %__MODULE__{contract: contract, key: key, durability: durability}

  @impl true
  def encode_xdr(%__MODULE__{
        contract: contract,
        key: key,
        durability: durability
      }) do
    [contract: contract, key: key, durability: durability]
    |> XDR.Struct.new()
    |> XDR.Struct.encode_xdr()
  end

  @impl true
  def encode_xdr!(%__MODULE__{
        contract: contract,
        key: key,
        durability: durability
      }) do
    [contract: contract, key: key, durability: durability]
    |> XDR.Struct.new()
    |> XDR.Struct.encode_xdr!()
  end

  @impl true
  def decode_xdr(bytes, struct \\ @struct_spec)

  def decode_xdr(bytes, struct) do
    case XDR.Struct.decode_xdr(bytes, struct) do
      {:ok,
       {%XDR.Struct{
          components: [contract: contract, key: key, durability: durability]
        }, rest}} ->
        {:ok, {new(contract, key, durability), rest}}

      error ->
        error
    end
  end

  @impl true
  def decode_xdr!(bytes, struct \\ @struct_spec)

  def decode_xdr!(bytes, struct) do
    {%XDR.Struct{
       components: [contract: contract, key: key, durability: durability]
     }, rest} = XDR.Struct.decode_xdr!(bytes, struct)

    {new(contract, key, durability), rest}
  end
end
